{****************************************************************************}
{*                                                                          *}
{*                          Vitus Graphic Interface                         *}
{*                               Version 2.5                                *}
{*           Easy, event driven, object oriented graphic interface          *}
{*                       for Turbo Pascal 5.5 or higher                     *}
{*                 Copyright (c) by Vitus B.Wagner, 1991-1993               *}
{*                                                                          *}
{*                              FILEDLG.PAS                           *}
{*                  ꥪ    䠩                 *}
{****************************************************************************}
{$I-}
unit FileDlg;
interface
uses Graph,DOS,Objects,VGIBase,VGILow,VgiDlg,VgiKeys,VgiText;
const

      {File dialog flags}
      {File existance}
      fdNewFile = $100;
      fdOldFile = $200;
      fdAnyFile = fdNewFile or fdOldFile;
      fdNoFile = $400;
      fdNoReadDir = $800;
      fdOpenButton = $10;
      fdOkButton = $20;
      fdReplaceButton =$40;
      fdClearButton = $80;
      {File dialog commands}
      cmOpenFile = 248;
      cmReplaceFile = 247;
      cmClearFile  = 246;
Type
     PFileInputLine = ^TFileInputLine;
     PFileListBox = ^TFileListBox;
     TFileInputLine = object(TInputLine)
                       Box:PFileListBox;
                       Constructor Init( X1,Y1,X2,Y2:Integer; AFlags:Word );
                       Constructor Load(var S:TStream);
                       Procedure Store(var S:TStream);
                       Function CheckExistance(Code:Word):Boolean;
                       Function IsWildCards:Boolean;
                       Function Handle(Code:Word):Integer;virtual;
                       Procedure SetData(var Rec);virtual;
                       Procedure GetData(var Rec);virtual;
                      end;
     TFileListBox = object(TListBox)
                     InputLine:PFileInputLine;
                     NewDir:PString;
                     OldDir:PString;
                     WildCard:String[13];
                     Procedure TargetDir;
                     Procedure HomeDir;
                     Constructor Init( X1,y1,x2,y2:Integer;  AScrollBar:PScrollbar;
                                      AInputLine:PFileInputLine; AWildCard:String;
                                      ReadDir:Boolean );
                     Constructor Load(var S:TStream);
                     Procedure Store(var S:TStream);
                     Procedure ReadDirectory(AWildCards:String);
                     Procedure SetDir(D:String);
                     Procedure SelectItem(Item:Integer);virtual;
                     Function DataSize:Word;virtual;
                     Procedure SetData(var Rec);virtual;
                     Procedure GetData(var Rec);virtual;
                     Function Handle(Code:Word):Integer;virtual;
                     Procedure Select;virtual;
                     Procedure Unselect;virtual;
                     Procedure SetFileName;
                     Destructor Done;virtual;
                   end;
    PFileCollection = ^TFileCollection;
    TFileCollection = object(TStringCollection)
                       Function Compare(Key1,Key2:Pointer):Integer;virtual;
                      end;
Function MakeFileDialog(ATitle,APrompt,AWildCard:String; Flags:Word):PDialog;
Function AskFileName(Atitle,APrompt:String;var FileName:String;
                     Mask:String;Flags:Word):Integer;
Const RFileInputLine : TStreamRec =
                     (ObjType:30;
                      VMTLink:Ofs(TypeOf(TFileInputLine)^);
                      Load:@TFileInputLine.Load;
                      Store:@TFileInputLine.Store);
Const RFileListBox : TStreamRec =
                     (ObjType:31;
                      VMTLink:Ofs(TypeOf(TFileListBox)^);
                      Load:@TFileListBox.Load;
                      Store:@TFileListBox.Store);
Procedure RegisterFileDlg;

implementation
const
 {Internal commands}
  cmRescan=258;
Procedure RegisterFileDlg;
begin
 RegisterType(RFileInputLine);
 RegisterType(RFileListBox);
end;
{*************** TFileInputLine *****************************}
Constructor TFileInputLine.Init(X1,Y1,X2,Y2:Integer;AFlags:Word);
begin
  TInputLine.Init(X1,y1,X2,y2,79);
  Flags:=Flags or AFlags;
end;
Function TFileInputLine.IsWildCards:Boolean;
begin
 isWildCards := (pos('?',Data^)<>0)or(Pos('*',Data^)<>0);
end;
Constructor TFileInputLine.Load(var S:TStream);
begin
 TInputLine.Load(S);
 GetControlPtr(S,PControl(Box));

end;
Procedure TFileInputLine.Store(var S:TStream);
begin
 TInputLine.Store(S);
 PutControlPtr(S,Box);
end;

Function TFileInputLine.Handle(Code:Word):Integer;
const EmptyString:String[2]='';
var      E:Extstr;
Function Positive(I:Integer):Integer;
begin
 if i<=0 then Positive:=1 else Positive:=i;
end;
begin
  Case Code of
    cmOk,cmOpenFile,cmReplaceFile :
     if IsWildCards then
     begin
      Handle:=-cmRescan;
     end
     else
      begin
      if Data^<>'' then
      if (Pos('.',Copy(Data^,Positive(Length(Data^)-3),4))=0 )and(Pos('.',Box^.WildCard)<>0) then
       begin
        E:=Copy(Box^.WildCard,Pos('.',Box^.WildCard),4);
        if(Pos('*',E)=0)and(Pos('?',E)=0) then Data^:=Data^+E;
       end;
        if CheckExistance(Code) then
        Handle:=0 else
         Handle:=cmEventProcessed;
      end;
    cmClearFile:begin
                 TInputLine.SetData(EmptyString);
                 Handle:=cmEventProcessed;
                end;
   else
    Handle:=TInputLine.Handle(code);
  end{______ of Case}
end;
Procedure TFileInputLine.SetData(var Rec);
var S:PathStr absolute rec;
    X:String[13];
    N:NameStr;
    E:ExtStr;
	D:DirStr;
	SR:SearchRec;
begin
 FindFirst(S,Directory,Sr);
 if (DosError<>0)or(sr.Attr<>Directory) then
 begin
  FSplit(S,D,N,E);
  X:=N+E;
 end
 else
 begin
  D:=S;
  X:=Box^.WildCard;
 end;
 TInputLine.SetData(X);
 Box^.SetDir(D);
end;
Procedure TFileInputLine.GetData(var Rec);
var S:String;E:extStr;
begin
 if Data^<>'' then
  begin
   if Box<>nil then
   begin
    Box^.TargetDir;
    S:=FExpand(Data^);
    Box^.HomeDir;
   end
  end
 else
 S:='';
  System.Move(S,Rec,Length(S)+1);
end;
Function TFileInputLine.CheckExistance(Code:Word):Boolean;
var Sr:SearchRec;
Procedure SendMessage(msg:String);
begin
 MoveTo(Limits.A.X,Limits.A.y);
 DrawText(AdjustString(Msg,DispLen+2));
 Beep;
 ClearEventQueue;
 Repeat until GetEvent<>0;
 Draw;
end;
begin
 if (Data^='') then
  begin
   CheckExistance:=(Flags and fdNoFile<>0);
   exit;
  end;

 if isWildCards then
  begin
   CheckExistance:=false;
   exit;
  end;
 Box^.TargetDir;
 FindFirst(Data^,Archive+ReadOnly,Sr);
 Box^.HomeDir;
 if Code=cmClearfile then CheckExistance:=True else
 Case DosError of
 0:if (Flags and fdOldFile<>0)or (Code=cmReplaceFile) then CheckExistance:=True
    else
      begin
        SendMessage('File already exist');
        CheckExistance:=False;
      end;
 18:if (Flags and fdNewFile<>0) then CheckExistance:=True
    else
     begin
      SendMessage('File doesn''t exist');
      CheckExistance:=false;
     end
   else
    begin
     SendMessage('Invalid file name');
     CheckExistance:=False;
    end;
 end;
end;
{******************** TFileListBox ********************************}
Constructor TFileListBox.Init(X1,y1,x2,y2:Integer;AScrollBar:PScrollbar;
            AInputLine:PFileInputLine;AWildCard:String;ReadDir:Boolean);
var S:STring;
begin
 TListBox.Init(X1,Y1,X2,Y2,AScrollBar);
 InputLine:=AInputLine;
 InputLine^.Box:=@Self;
 if AWildCard='' then AWildCard:='*.*';
 GetDir(0,S);
 OldDir:=NewStr(S);
 NewDir:=NewStr(S);
 if ReadDir then ReadDirectory(AWildCard);
end;
Constructor TFileListBox.Load(var S:TStream);
var D:String;P:PString;
begin
 TListBox.Load(S);
 GetControlPtr(S,PControl(InputLine));
 GetDir(0,D);
 NewDir:=NewStr(D);
 OldDir:=NewStr(D);
 P:=S.ReadStr;
 WildCard:=P^;
 DisposeStr(P);
 ReadDirectory(WildCard);
end;
Procedure TFileListBox.Store(var S:TStream);
begin
 TListBox.Store(S);
 PutControlPtr(S,InputLine);
 S.WriteStr(@WildCard);
end;
Procedure TFileListBox.SetDir(D:String);
begin
 if (D[Length(D)]='\')and(Length(D)>3)or(D[2]<>':') then dec(D[0]);
 Chdir(D);
 if IOResult<>0 then exit;
 if NewDir<>nil then DisposeStr(NewDir);
 NewDir:=NewStr(D);
 ReadDirectory(WildCard);
end;
Procedure TFileListBox.SelectItem(Item:Integer);
begin
 Owner^.PutCommand(kbEnter);
end;
Procedure TFileListBox.ReadDirectory(AWildCards:String);
var P:PCollection;
    S:SearchRec;
    Path:DirStr;
    Name:NameStr;
    Ext:ExtStr;
    NM:String;
begin
 P:=New(PFileCollection,Init(8,4));
 TargetDir;
 NM:=FExpand(AWildCards);
 FSplit(NM,Path,Name,Ext);
 WildCard:=Name+Ext;
 if Length(Path)>3 then Dec(Path[0]);
 if Path<>NewDir^ then
  begin
   if NewDir<>nil then DisposeStr(NewDir);
   NewDir:=NewStr(Path);
   TargetDir;
  end;
 FindFirst(WildCard,Archive+ReadOnly,s);
 While DosError=0 do
  begin
   P^.Insert(NewStr(S.Name));
   FindNext(S);
  end;
 FindFirst('*.*',Directory,S);
 While DosError=0 do
  begin
   if (S.Attr=Directory) and (S.Name<>'.') then
    P^.Insert(NewStr(S.Name+'\'));
   FindNext(S);
  end;
 Focused:=0;
 NewList(P);
 if (Owner<>nil)and(Owner^.Current<>@Self) then HomeDir;
end;
Function TFileListBox.DataSize:Word;
begin
 DataSize:=0;
end;
Procedure TFileListBox.SetData(var Rec);
begin

end;
Procedure TFileListBox.GetData(var Rec);
begin

end;
Destructor TFileListBox.Done;
begin
 if newDir<>nil then DisposeStr(NewDir);
 NewList(nil);
 if OldDir<>nil then DisposeStr(OldDir);
 TListBox.Done;
end;
Function TFileListBox.Handle(Code:Word):Integer;
var OldFocus:integer;S:String;
begin
  case Code of
  cmRescan:
   begin
    ReadDirectory(InputLine^.Data^);
    Owner^.SelectControl(@Self);
    Handle:=cmEventProcessed;
    exit;
   end;
 else
 OldFocus:=Focused;
 Handle:=TListBox.Handle(Code);
 if Focused<>OldFocus then
  SetFileName;
 end;
end;
Procedure TFileListBox.TargetDir;
begin
 ChDir(NewDir^);
end;
Procedure TFileListBox.Select;
begin
 TListBox.Select;
 SetFileName;
 TargetDir;
end;
Procedure TFileListBox.UnSelect;
begin
 HomeDir;
 TListBox.Unselect;
end;
Procedure TFileListBox.SetFileName;
var S:String;
begin
 S:=GetText(Focused);
 if S[Length(S)]='\' then S:=S+WildCard;
 InputLine^.Data^:=S;
 if (Owner<>nil)and(Owner^.Visible>0) then InputLine^.Draw;
end;
Procedure TFileListBox.HomeDir;
begin
 ChDir(OldDir^);
end;
{******************** TFileCollection **************************}
Function TFileCollection.Compare(Key1,Key2:Pointer):Integer;
var S1 : PString absolute Key1;
    S2 : PString absolute Key2;
begin
 if S1^[Length(S1^)]='\' then
  if S2^[Length(S2^)]='\' then Compare:=TStringCollection.Compare(Key1,Key2)
   else Compare:=1
 else
 if S2^[Length(S2^)]='\' then Compare:=-1
  else
  Compare:=TStringCollection.Compare(Key1,Key2)
end;
{********************** TFileDialog *******************************}
Function MakeFileDialog(ATitle,APrompt,AWildCard:String;Flags:Word):PDialog;
var s:String;X:Integer;
    Inp:PFileInputLine;
    Scroll:PScrollBar;
    ButtonRect:TRect;
    DefButton:Boolean;
    DlG:PDialog;
    Step:Integer;
Procedure MakeButton(Text:String;Command:integer);
begin
 With ButtonRect do
 Dlg^.Insert(New(PButton,Init(A.X,A.Y,B.X,B.Y,Text,Command,DefButton)));
 ButtonRect.Move(0,Step+10);
 DefButton:=false;
end;
begin
 Step:=FontSize+1;

 Dlg:=New(PDialog,Init(000,0,240,FontSize*14+2,ATitle));
 GetDir(0,S);
 Inp:=New(PFileInputLine,Init(10,Step*2,230,Step*3+1,Flags and $F00));
 Dlg^.Insert(New(PLabel,Init(10,Step,230,Step*2,APrompt,Inp)));
 Dlg^.Insert(Inp);
 Scroll:=New(PScrollBar,Init(120,Step*4-5,128,FontSize*14-7,True));
 Dlg^.Insert(New(PFileListBox,Init(10,Step*4-5,120,FontSize*14-7,Scroll,Inp,AWildCard,
 Flags and fdNoReadDir =0 )));
 Dlg^.Insert(Scroll);
 Inp^.SetData(AwildCard);
 DefButton:=True;
 ButtonRect.Assign(140,Step*4-5,230,Step*5);
 if Flags and fdOpenButton<>0 then MakeButton('~O~pen',-cmOpenFile);
 if Flags and fdOkButton<>0 then MakeButton('O~k~',-cmOk);
 if Flags and fdReplaceButton<>0 then MakeButton('~R~eplace',-cmReplaceFile);
 if Flags and fdClearButton<>0 then MakeButton('~C~lear',-cmClearFile);
 MakeButton('C~a~ncel',cmCancel);
 Dlg^.Move((MaxGraphX-240) div 2,(MaxGraphY-FontSize*14-2) div 2);
 Dlg^.SelectNext;
 MakeFileDialog:=Dlg;
end;
Function AskFileName(Atitle,APrompt:String;var FileName:String;
                     Mask:String;Flags:Word):Integer;
var D:PDialog;
    Dir:DirStr;
    N:nameStr;
    E:ExtStr;
    Cmd:Integer;
begin
  Fsplit(Filename,Dir,N,E);
  D:=MakeFileDialog(Atitle,APrompt,Mask,Flags and not fdNoReadDir  );
  D^.SetData(Filename);
  Cmd:=D^.Execute;
  if Cmd<>cmCancel then
   D^.getData(FileName);
  AskFileName:=Cmd;
  Dispose(D,Done);
end;
end.
